Index: trunk/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1531)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 1532)
@@ -877,23 +709,41 @@
       ENDIF
 
-      ! Initialization of vertical eddy coef. to the background value
-      ! -------------------------------------------------------------
+      !                               !* depth of penetration of surface tke
+      IF( nn_etau /= 0 ) THEN      
+         SELECT CASE( nn_htau )           ! Choice of the depth of penetration
+         CASE( 0 )                                    ! constant depth penetration (here 10 meters)
+            htau(:,:) = 10.e0
+         CASE( 1 )                                    ! F(latitude) : 5m to 40m at high lat.
+            DO jj = 1, jpj
+               DO ji = 1, jpi  
+                  htau(ji,jj) = MAX( 5., MIN( 40., 60.*ABS( SIN( rpi/180. * gphit(ji,jj) ) ) )   )
+               END DO
+            END DO
+         CASE( 2 )                                    ! F(latitude) : 5m to 60m at high lat.
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  htau(ji,jj) =  MAX( 5.,6./4.* MIN( 40., 60.*ABS( SIN( rpi/180. * gphit(ji,jj) ) ) )   )
+               END DO
+            END DO
+         END SELECT
+      ENDIF
+
+      !                               !* set vertical eddy coef. to the background value
       DO jk = 1, jpk
          avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
+         avm (:,:,jk) = avmb(jk) * tmask(:,:,jk)
          avmu(:,:,jk) = avmb(jk) * umask(:,:,jk)
          avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
       END DO
-
-
-      ! read or initialize turbulent kinetic energy ( en )
-      ! -------------------------------------------------
+      dissl(:,:,:) = 1.e-12
+      !                               !* read or initialize all required files 
       CALL tke_rst( nit000, 'READ' )
       !
-   END SUBROUTINE zdf_tke_init
+   END SUBROUTINE tke_init
 
 
    SUBROUTINE tke_rst( kt, cdrw )
      !!---------------------------------------------------------------------
-     !!                   ***  ROUTINE ts_rst  ***
+     !!                   ***  ROUTINE tke_rst  ***
      !!                     
      !! ** Purpose :   Read or write TKE file (en) in restart file
@@ -906,26 +756,55 @@
      CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
      !
-     INTEGER ::   jit   ! dummy loop indices
+     INTEGER ::   jit, jk   ! dummy loop indices
+     INTEGER ::   id1, id2, id3, id4, id5, id6
      !!----------------------------------------------------------------------
      !
-     IF( TRIM(cdrw) == 'READ' ) THEN
-        IF( ln_rstart ) THEN
-           IF( iom_varid( numror, 'en', ldstop = .FALSE. ) > 0 .AND. .NOT.(ln_rstke) ) THEN 
+     IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise 
+        !                                   ! ---------------
+        IF( ln_rstart ) THEN                   !* Read the restart file
+           id1 = iom_varid( numror, 'en'   , ldstop = .FALSE. )
+           id2 = iom_varid( numror, 'avt'  , ldstop = .FALSE. )
+           id3 = iom_varid( numror, 'avm'  , ldstop = .FALSE. )
+           id4 = iom_varid( numror, 'avmu' , ldstop = .FALSE. )
+           id5 = iom_varid( numror, 'avmv' , ldstop = .FALSE. )
+           id6 = iom_varid( numror, 'dissl', ldstop = .FALSE. )
+           !
+           IF( id1 > 0 ) THEN                       ! 'en' exists
               CALL iom_get( numror, jpdom_autoglo, 'en', en )
-           ELSE
-              IF( lwp .AND. iom_varid( numror, 'en', ldstop = .FALSE. ) > 0 )   &
-                 &                       WRITE(numout,*) ' ===>>>> : previous run without tke scheme'
-              IF( lwp .AND. ln_rstke )   WRITE(numout,*) ' ===>>>> : We do not use en from the restart file'
-              IF( lwp                )   WRITE(numout,*) ' ===>>>> : en is set by iterative loop'
+              IF( MIN( id2, id3, id4, id5, id6 ) > 0 ) THEN        ! all required arrays exist
+                 CALL iom_get( numror, jpdom_autoglo, 'avt'  , avt   )
+                 CALL iom_get( numror, jpdom_autoglo, 'avm'  , avm   )
+                 CALL iom_get( numror, jpdom_autoglo, 'avmu' , avmu  )
+                 CALL iom_get( numror, jpdom_autoglo, 'avmv' , avmv  )
+                 CALL iom_get( numror, jpdom_autoglo, 'dissl', dissl )
+              ELSE                                                 ! one at least array is missing
+                 CALL tke_avn                                          ! compute avt, avm, avmu, avmv and dissl (approximation)
+              ENDIF
+           ELSE                                     ! No TKE array found: initialisation
+              IF(lwp) WRITE(numout,*) ' ===>>>> : previous run without tke scheme, en computed by iterative loop'
               en (:,:,:) = rn_emin * tmask(:,:,:)
-              DO jit = 2, nn_itke + 1
-                 CALL zdf_tke_old( jit )
-              END DO
+              CALL tke_avn                               ! recompute avt, avm, avmu, avmv and dissl (approximation)
+              DO jit = nit000 + 1, nit000 + 10   ;   CALL zdf_tke( jit )   ;   END DO
            ENDIF
-        ELSE
-           en(:,:,:) = rn_emin * tmask(:,:,:)      ! no restart: en set to its minimum value
+        ELSE                                   !* Start from rest
+           en(:,:,:) = rn_emin * tmask(:,:,:)
+           DO jk = 1, jpk                           ! set the Kz to the background value
+              avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
+              avm (:,:,jk) = avmb(jk) * tmask(:,:,jk)
+              avmu(:,:,jk) = avmb(jk) * umask(:,:,jk)
+              avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
+           END DO
         ENDIF
-     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
-        CALL iom_rstput( kt, nitrst, numrow, 'en', en )
+        !
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
+        !                                   ! -------------------
+        IF(lwp) WRITE(numout,*) '---- tke-rst ----'
+        CALL iom_rstput( kt, nitrst, numrow, 'en'   , en     )
+        CALL iom_rstput( kt, nitrst, numrow, 'avt'  , avt    )
+        CALL iom_rstput( kt, nitrst, numrow, 'avm'  , avm    )
+        CALL iom_rstput( kt, nitrst, numrow, 'avmu' , avmu   )
+        CALL iom_rstput( kt, nitrst, numrow, 'avmv' , avmv   )
+        CALL iom_rstput( kt, nitrst, numrow, 'dissl', dissl  )
+        !
      ENDIF
      !
@@ -936,11 +815,15 @@
    !!   Dummy module :                                        NO TKE scheme
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_zdftke_old = .FALSE.   !: TKE flag
+   LOGICAL, PUBLIC, PARAMETER ::   lk_zdftke = .FALSE.   !: TKE flag
 CONTAINS
-   SUBROUTINE zdf_tke_old( kt )          ! Empty routine
-      WRITE(*,*) 'zdf_tke_old: You should not have seen this print! error?', kt
-   END SUBROUTINE zdf_tke_old
+   SUBROUTINE zdf_tke( kt )          ! Empty routine
+      WRITE(*,*) 'zdf_tke: You should not have seen this print! error?', kt
+   END SUBROUTINE zdf_tke
+   SUBROUTINE tke_rst( kt, cdrw )
+     CHARACTER(len=*) ::   cdrw
+     WRITE(*,*) 'tke_rst: You should not have seen this print! error?', kt, cdwr
+   END SUBROUTINE tke_rst
 #endif
 
    !!======================================================================
-END MODULE zdftke_old
+END MODULE zdftke
